#include <sys/types.h>
#include <sys/mman.h>
#include <sys/wait.h>

#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void *f1(void);
void *f2(void);

static int m;

void *
stack_addr(void)
{
	int s;

	return (void *)(uintptr_t)&s;
}

#ifndef MAP_32BIT
#define MAP_32BIT 0
#endif

void
header(void)
{

	printf("exec               malloc4k           malloc4m           mmap4k             mmap4k32           mmap4m             so1                so2                stack            \n");
}

void
fn(void)
{
	void *m1 = malloc(4096);
	void *m2 = malloc(4 * 1024 * 1024);
	void *m3 = mmap(NULL, 4096, PROT_READ | PROT_WRITE, MAP_ANON, -1, 0);
	void *m4 = mmap(NULL, 4096, PROT_READ | PROT_WRITE, MAP_ANON | MAP_32BIT, -1, 0);
	void *m5 = mmap(NULL, 4 * 1024 * 1024, PROT_READ | PROT_WRITE, MAP_ANON, -1, 0);

#ifdef __LP64__
#define FMT "0x%016llx"
#else
#define FMT "0x%08llx"
#endif

	printf(FMT " " FMT " " FMT " " FMT " " FMT " " FMT " " FMT " " FMT " " FMT "\n",
	    (unsigned long long)&m,
	    (unsigned long long)m1,
	    (unsigned long long)m2,
	    (unsigned long long)m3,
	    (unsigned long long)m4,
	    (unsigned long long)m5,
	    (unsigned long long)f1(),
	    (unsigned long long)f2(),
	    (unsigned long long)stack_addr());
}

void
forkloop(size_t count, const char *argv0)
{
	const char *args[] = {NULL, "1", NULL};
	const char *env[] = {NULL};
	int status;

	args[0] = argv0;
	for (size_t i = 0; i < count; i++) {
		switch (fork()) {
		case -1:
			err(1, "fork");
			break;
		case 0:
			if (execve(argv0, (char * const*)args, (char * const*)env) != 0)
				err(1, "execve");
			break;
		default:
			wait(&status);
			break;
		}
	}
}

int
main(int argc, char *argv[])
{
	size_t s;

	if (argc > 1)
		s = atoi(argv[1]);
	else
		s = 4;

	if (s == 1) {
		fn();
		exit(0);
	}

	header();
	forkloop(s, argv[0]);
}
